from random import *

def ecart6(n):
    """Simule n lancers d'un dé dont la proba de faire 6 est 1/6. Renvoie l'écart de la fréquence d'apparition du 6 avec 1/6."""
    
    c = 0
    for i in range(n):
        if random() < 1/6:
            c = c + 1
        
    return abs(c/n-1/6)
    
def Nechantillons(N,n):
    """Simule N échantillons de n lancers d'un dé dont la proba de faire 6 est 1/6. Renvoie la fréquence du nombre de fois où l'écart avec 1/6 a dépassé 0,01"""
    
    c = 0
    for i in range(N):
        e = ecart6(n)
        if e > 0.01:
            c = c + 1
    
    return c/N


# Exemples d'utilisation avec un dé équilibré
print("Proportion des échantillons pour lesquels la proportion de 6 diffère de plus de 0,01 de 1/6")
print("Avec un dé équilibré:")
print(Nechantillons(500,100))
print(Nechantillons(500,1000))
print(Nechantillons(500,10000))
print(Nechantillons(500,27778)) 


