from random import *
from math import *
from matplotlib.pyplot import *


# Partie simulation

def bernoulli(p):
    return random() <= p
    
def binomiale(n,p):
    """ Simule un schéma de Bernoulli et renvoie le nombre de succès""" 
    s=0
    for i in range(n):
        if bernoulli(p):
            s=s+1
    
    return s
    
def Nechantillons(N,n,p):
    """ Simule N fois la loi binomiale B(n,p) et renvoie la fréquence observée des 
        des expériences pour lesquels X est éloigné de p.n de plus de sqrt(n)"""
    
    c = 0
    for i in range(N):
        s = binomiale(n,p)
        
        if abs(s-p*n)>sqrt(n):
            c = c+1
    
    return c/N ,p*(1-p)     # p*(1-p) est la valeur donnée par Bienaymé-Tchebychev


def courbe(N,n):
    """ Trace la courbe de la probabilité P(|Sn-np|>sqrt(n)) en fonction de p"""
    nb=n #min(n,100)
    
    X=[i/nb for i in range(nb+1)]
    Y=[Nechantillons(N,n,p) for p in X]
    plot(X,Y)
    show()




N,n = 2000,100
# Pour des grandes valeurs de N, cela peut prendre du temps...
# Mais plus N est petit, plus les chances de dépasser 0,05 sont grandes.
courbe(N,n)
