from random import *
from math import *

""" Une simule N échantillons de taille n d'une v.a.
    Pour chaque échantillons, on calcule la moyenne des succès des n expériences.
    On obtient donc une série statistiques de N valeurs. 
    On calcule sa moyenne et son écart-type. 
    On compte alors la proportion de ces échantillons dont la moyenne s'écarte entre 1 à 3 fois l'écart-type de l'espérance"""
    

    
def loi():
    """ Simule le lancer de 2 dé et on renvoie la somme des deux."""
    de1 = randint(1,6)
    de2 = randint(1,6)   
    return de1+de2
    
        
def echantillon(n):
    """ Simule un échantillon de taille n d'expérience suivant la loi précédente.
        La fonction renvoie la moyenne des résultats obtenus"""
    s = 0
    for i in range(n):
        s = s + loi()
    return s/n
    

def Nechantillons(N,n):
    """ Simule N échantillons de taille n d'expériences suivant la loi précédente.
        La fonction renvoie la liste des moyennes obtenues"""
    
    liste = []
    
    # On simule
    for i in range(N):
        m = echantillon(n)
        liste.append(m)
    
    return liste
    

def ecart_type(liste):
    """ Renvoie l'écart-type d'une liste de valeurs."""
    # nombre d'éléments
    N = len(liste)
    # Calcule de la moyenne de cette série
    moyenne = sum(liste)/N
    
    # Calcule de la variance (var) et de l'écart-type (ec) de cette série
    s = 0
    for nb in liste:
        s = s + (nb-moyenne)**2
    
    var = s/N
    ec = sqrt(var)
    return ec
    
    
def proportion_intervalle(liste,mu,ec):
    """ Renvoie la proportion des valeurs de la liste qui s'écarte d'une espérance mu de 1 fois,
    2 fois et 3 fois d'un écart type ec."""
    
    freq = [0,0,0]
    
    for m in liste:
        ecart = abs(m-mu)
        for k in range(3):
            if ecart <= (k+1)*ec:
                freq[k]=freq[k]+1
    
    for k in range(3):
        freq[k]=freq[k]/len(liste)
        
    return freq
    

# espérance et écart-type de la loi 
mu = 7
sigma = 2.41523
N = 10000
n = 100

# liste contenant la moyenne pour chaque échantillons.
liste_moyennes = Nechantillons(N,n)

# Calcule de la moyenne de cette série
moyenne = sum(liste_moyennes)/N

# l'écart-type (s) de cette série
s = ecart_type(liste_moyennes) 

# On affiche pour comparer cet écart-type à sigma/sqrt(n)
print("Comparaison de l'écart-type s de la série avec sigma/sqrt(n)")
print("s =",s)
print("sigma/sqrt(n) =",sigma/sqrt(n))


# proportion des valeurs de la liste qui s'écarte de mu de 1 fois, 2 fois et 3 fois de s
freq =proportion_intervalle(liste_moyennes,mu,s) #sigma/sqrt(n))    
    
print()
print("Proportion des échantillons pour lesquels l'écart entre la moyenne et mu est inférieur à ks, pour k=1, 2 et 3 :")
print(freq)
    
            
    
    
    
        
    
        
        
        
